package net.brokenmoon.afloydwiremod;

import net.brokenmoon.afloydwiremod.api.AbstractWireTileEntity;
import net.brokenmoon.afloydwiremod.item.ToolWiring;
import net.brokenmoon.afloydwiremod.mixin.AccessorPacket;
import net.brokenmoon.afloydwiremod.packet.*;
import net.brokenmoon.afloydwiremod.ter.TERDisplay;
import net.brokenmoon.afloydwiremod.ter.TERWire;
import net.brokenmoon.afloydwiremod.tile.ChipTile;
import net.brokenmoon.afloydwiremod.item.ToolProgrammer;
import net.brokenmoon.afloydwiremod.tile.DisplayTile;
import net.brokenmoon.afloydwiremod.tile.RedstoneLinkTile;
import net.brokenmoon.afloydwiremod.tileentity.*;
import net.fabricmc.api.ModInitializer;
import net.minecraft.src.Block;
import net.minecraft.src.Item;
import net.minecraft.src.Material;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import turniplabs.halplibe.helper.BlockHelper;
import turniplabs.halplibe.helper.EntityHelper;
import turniplabs.halplibe.helper.ItemHelper;


public class WireMod implements ModInitializer {
    public WireMod(){
        AccessorPacket.callAddIdClassMapping(109, true, true, WiremodProgrammerGuiPacket.class);
        AccessorPacket.callAddIdClassMapping(110, true, true, WiremodProgrammerPacket.class);
        AccessorPacket.callAddIdClassMapping(111, true, true, WiremodWiringGuiPacket.class);
        AccessorPacket.callAddIdClassMapping(112, true, true, WiremodPacketSyncIO.class);
        AccessorPacket.callAddIdClassMapping(113, true, true, WiremodWiringPacket.class);
        AccessorPacket.callAddIdClassMapping(114, true, true, WiremodSettingsGuiPacket.class);
        AccessorPacket.callAddIdClassMapping(500, true, true, WiremodWireGuiPacket.class);
    }

    public static final String MOD_ID = "afloydwiremod";
    public static final Logger LOGGER = LoggerFactory.getLogger(MOD_ID);

    public static Block ChipTile = BlockHelper.createBlock(MOD_ID, new ChipTile(905, Material.iron), "chipTile", "chip.png", Block.soundMetalFootstep,1.5f, 6f, 0 );

    public static Item ToolProgrammer = ItemHelper.createItem(MOD_ID, new ToolProgrammer(906), "toolProgrammer", "progtool.png");
    public static ToolWiring ToolWiringClass = new ToolWiring(907);
    public static Item ToolWiring = ItemHelper.createItem(MOD_ID, ToolWiringClass, "toolWiring", "wiretool.png");

    public static Block LinkTileInactive = BlockHelper.createBlock(MOD_ID, new RedstoneLinkTile(908, Material.iron, false), "linkTile", "linkOff.png", Block.soundStoneFootstep, 1.5f, 6f, 0);
    public static Block LinkTileActive = BlockHelper.createBlock(MOD_ID, new RedstoneLinkTile(909, Material.iron, true), "linkTile", "linkOn.png", Block.soundStoneFootstep, 1.5f, 6f, 0);
    public static Block ScreenTile = BlockHelper.createBlock(MOD_ID, new DisplayTile(910, Material.glass), "displayTile", "display.png", Block.soundGlassFootstep, 1.5f, 6f, 0);

    @Override
    public void onInitialize() {
        LOGGER.info("WireMod initialized.");
        LinkTileActive.notInCreativeMenu = true;
        EntityHelper.createTileEntity(ChipTileEntity.class, "Chip");
        EntityHelper.createTileEntity(RedstoneLinkTileEntity.class, "Redstone Link");
        EntityHelper.createSpecialTileEntity(AbstractWireTileEntity.class, new TERWire(), "Wire");
        EntityHelper.createSpecialTileEntity(DisplayTileEntity.class, new TERDisplay(), "Display");
    }
}
